/* Module:          psqlodbc.c
 *
 * Description:     This module contains the main entry point (DllMain) for the library.
 *                  It also contains functions to get and set global variables for the
 *                  driver in the registry.
 *
 * Classes:         n/a
 *
 * API functions:   none
 *
 * Comments:        This file licensed under the LGPL, see: http://www.gnu.org/licenses/lgpl.html
 *
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

//#include "psqlodbc.h"
//#include "dlg_specific.h"

#include <sql.h>
#include <odbcinst.h>

//GLOBAL_VALUES globals;

RETCODE SQL_API SQLDummyOrdinal(void);


#ifndef TRUE
#define TRUE	1
#endif
#ifndef FALSE
#define FALSE	0
#endif

#ifdef __GNUC__

/* This function is called at library initialization time.  */

static BOOL
__attribute__((constructor))
init(void)
{
//	getGlobalDefaults(DBMS_NAME, ODBCINST_INI, FALSE);
	return TRUE;
}

#else /* not __GNUC__ */

#ifdef DONT_DO_IT

/* These two functions do shared library initialziation on UNIX, well at least
 * on Linux. I don't know about other systems.
 */
BOOL
_init(void)
{
//	getGlobalDefaults(DBMS_NAME, ODBCINST_INI, FALSE);
	return TRUE;
}

BOOL
_fini(void)
{
	return TRUE;
}

#endif /* not __GNUC__ */

#endif


/*	This function is used to cause the Driver Manager to
	call functions by number rather than name, which is faster.
	The ordinal value of this function must be 199 to have the
	Driver Manager do this.  Also, the ordinal values of the
	functions must match the value of fFunction in SQLGetFunctions()
*/
RETCODE SQL_API SQLDummyOrdinal(void)
{
	return SQL_SUCCESS;
}

